package com.steerinfo.baseinfo.meterbasediffrelation.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasediffrelation.model.MeterBaseDiffRelation;
import com.steerinfo.baseinfo.meterbasediffrelation.service.IMeterBaseDiffRelationService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;

/**
 * MeterBaseDiffRelation RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-18 02:08
 * 类描述
 * 修订历史：
 * 日期：2020-06-18
 * 作者：generator
 * 参考：
 * 描述：MeterBaseDiffRelation RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasediffrelations")
public class MeterBaseDiffRelationController extends BaseRESTfulController {

    @Autowired
    IMeterBaseDiffRelationService meterBaseDiffRelationService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasediffrelation:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseDiffRelation> list = meterBaseDiffRelationService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasediffrelation:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseDiffRelation> list = meterBaseDiffRelationService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseDiffRelation对象创建")
    @ApiImplicitParam(name = "meterBaseDiffRelation", value = "详细实体meterBaseDiffRelation", required = true, dataType = "MeterBaseDiffRelation")
    //@RequiresPermissions("meterbasediffrelation:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody List<MeterBaseDiffRelation> models) {
        try {
            String msg = meterBaseDiffRelationService.checkandadd(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasediffrelation:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseDiffRelation meterBaseDiffRelation = meterBaseDiffRelationService.getById(id);
            return success(meterBaseDiffRelation);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseDiffRelation信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseDiffRelation", value = "详细实体meterBaseDiffRelation", required = true, dataType = "MeterBaseDiffRelation")
    })
    //@RequiresPermissions("meterbasediffrelation:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseDiffRelation model) {
        try {
            model.setId(id);
            MeterBaseDiffRelation meterBaseDiffRelation = meterBaseDiffRelationService.modify(model);
            return success(meterBaseDiffRelation);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的meterBaseDiffRelation实体类来指定删除对象")
    @ApiImplicitParam(name = "meterBaseDiffRelation", value = "详细实体meterBaseDiffRelation", required = true, dataType = "MeterBaseDiffRelation")
    //@RequiresPermissions("meterbasediffrelation:delete")
    @PutMapping(value = "/")
    public RESTfulResult delete(@RequestBody List<MeterBaseDiffRelation> models) {
        try {
            List<String> list = new ArrayList<String>();
            for (MeterBaseDiffRelation model : models) {
                String id = model.getId();
                list.add(id);
            }
            List<String> ids = ListUtils.convertList(list);
            meterBaseDiffRelationService.delete(ids);
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
